import 'package:flutter/material.dart';
import 'package:itplugin/models/it_drawer_prefs.dart';

export '../models/it_drawer_prefs.dart';

class ItDrawer extends StatelessWidget {
  const ItDrawer({Key key, this.prefs}) : assert(prefs != null, ), super(key: key);

  final ItDrawerPrefs prefs;

  @override
  Widget build(BuildContext context) {
    return Drawer(
      child: ListView(
        children: <Widget>[
          GestureDetector(
            onTap: prefs.header.onTap,
            child: Container(
              height: prefs.header.height,
              child: prefs.header.child,
            ),
          ),
          prefs.body != null ?
          prefs.body.child : Container()
        ],
      ),
    );
  }
}
