import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class ItFlatButton extends StatefulWidget {
  final String text;
  final Color color;
  final double borderRadius;
  final double height;
  final double width;
  final Function onClick;
  final TextStyle textStyle;
  final GlobalKey<FormState> formKey;
  final EdgeInsetsGeometry margin;
  final EdgeInsetsGeometry padding;
  final Background background;

  ItFlatButton(this.text,
      {Key key,
      this.margin,
      this.height,
      this.color,
      this.padding,
      this.onClick,
      this.textStyle,
      this.width = 100,
      this.borderRadius = 10,
      this.formKey,
      this.background})
      : assert(
            background == null || color == null,
            'Impossivel usar uma cor com um widget de fundo\n'
            'Escolha entre um widget de fundo ou uma cor.'),
        super(key: key);

  @override
  _ItFlatButtonState createState() => _ItFlatButtonState();
}

class _ItFlatButtonState extends State<ItFlatButton> {
  @override
  Widget build(BuildContext context) {
    return SizedBox(
      height: widget.height,
      width: widget.width,
      child: Container(
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(widget.borderRadius),
            color: widget.background != null
                ? widget.background.backgroundColor
                : widget.color),
        margin: widget.margin,
        padding: widget.padding,
        child: FlatButton(
          onPressed: widget.onClick,
          shape: RoundedRectangleBorder(
              borderRadius: BorderRadius.circular(widget.borderRadius)),
          padding: EdgeInsets.all(0.0),
          child: Ink(
            decoration: BoxDecoration(
                borderRadius: BorderRadius.circular(widget.borderRadius)),
            child: Material(
              type: MaterialType.transparency,
              child: Stack(
                children: [
                  Container(
                    constraints: BoxConstraints(
                      maxWidth: widget.width,
                      minHeight: 50.0,
                    ),
                    alignment: Alignment.center,
                    child: widget.background != null
                        ? widget.background.child
                        : Container(),
                  ),
                  Container(
                    constraints:
                        BoxConstraints(maxWidth: widget.width, minHeight: 50.0),
                    alignment: Alignment.center,
                    child: Text(
                      widget.text,
                      textAlign: TextAlign.center,
                      style: widget.textStyle,
                    ),
                  ),
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }
}

class Background {
  Background({this.child, this.backgroundColor = Colors.transparent});

  Widget child;
  Color backgroundColor;
}
