import 'package:flutter/material.dart';

class ItRate extends StatefulWidget {
  ItRate(
      {Key key,
      this.rate,
      this.mainAxisAlignment = MainAxisAlignment.start,
      this.fullIcon,
      this.halfIcon,
      this.emptyIcon,
      this.iconSize = 20})
      : assert(rate != null),
        assert(rate >= 0 && rate <= 10),
        assert(fullIcon != null),
        assert(halfIcon != null),
        assert(emptyIcon != null),
        super(key: key);
  final int rate;
  final MainAxisAlignment mainAxisAlignment;
  final IconData fullIcon;
  final IconData halfIcon;
  final IconData emptyIcon;
  final double iconSize;

  @override
  _ItRateState createState() => _ItRateState();
}

class _ItRateState extends State<ItRate> {
  @override
  Widget build(BuildContext context) {
    List<Widget> list = <Widget>[];
    bool half = true;
    for (int j = 1; j < 10; j += 2) {
      if (widget.rate > j) {
        list.add(Icon(widget.fullIcon, size: widget.iconSize, color: Color(0xFF004d66)));
      } else {
        if (widget.rate % 2 != 0 && half) {
          list.add(Icon(widget.halfIcon, size: widget.iconSize, color: Color(0xFF004d66)));
          half = false;
        } else {
          list.add(Icon(widget.emptyIcon, size: widget.iconSize, color: Color(0xFF004d66)));
        }
      }
    }

    return Row(
        crossAxisAlignment: CrossAxisAlignment.center,
        mainAxisAlignment: widget.mainAxisAlignment,
        children: list);
  }
}
